Newsgroups: comp.mail.sendmail
Subject: sendmail-5.65c+IDA-1.4.4 patch kit
Reply-To: Paul-Pomes@uiuc.edu

This patch kit corrects a number of problems encountered with the latest
release of the UIUC/NIU version of the IDA sendmail kit.

Files in the ida/aux directory now include just sendmail.h instead of the
previous morass.

Includes a sample ida/cf/M4/{athena.m4,mailers.ptx} files for use on
Sequent PTX machines.

ida/cf/Sendmail.mc has an important fix applied that corrects an argument
mis-match.

Previously posted fixes to the QSELREF patch included.

All non-fatal syslog() calls have been eliminated prior to the freeze()
operation.  This permits freeze file operation on additional systems.

The last char of a string returned by yp_match() is zapped only if it's
a newline.

New logdelivery() routine copes with small syslog() buffers and with
limited number of arguments permitted in syslog().

Apply this patch by saving to a file, cd to just above the sendmail source
directory, and then feed this file to patch ala

	patch -p0 < thisfile

/pbp
====
diff -r -c -b sendmail-5.65c/ida/aux/Makefile sendmail/ida/aux/Makefile
*** sendmail-5.65c/ida/aux/Makefile	Tue Mar  5 11:51:42 1991
--- sendmail/ida/aux/Makefile	Tue Jul  2 12:32:53 1991
***************
*** 9,19 ****
  #
  
  BINS=		dbm mkdomext scanf xalparse
! CFLAGS=		-O -DVMUNIX -I$(INCLUDEDIR)
  
  #  The following definitions are inserted by ../Makefile
  #  Change them there--not here!
! CC=		gcc -ansi -Dvax -fpcc-struct-return -fstrength-reduce
  BINDIR=		/usr/local/bin
  LIBDIR=		/usr/local/lib/mail
  SRCDIR=		../../src
--- 9,19 ----
  #
  
  BINS=		dbm mkdomext scanf xalparse
! CFLAGS=		-O -I$(INCLUDEDIR)
  
  #  The following definitions are inserted by ../Makefile
  #  Change them there--not here!
! CC=		cc
  BINDIR=		/usr/local/bin
  LIBDIR=		/usr/local/lib/mail
  SRCDIR=		../../src
diff -r -c -b sendmail-5.65c/ida/aux/dbm.c sendmail/ida/aux/dbm.c
*** sendmail-5.65c/ida/aux/dbm.c	Tue Jun 25 17:50:29 1991
--- sendmail/ida/aux/dbm.c	Mon Jul  1 11:29:11 1991
***************
*** 6,45 ****
  **  Use it, abuse it, but don't sell it.
  */
  
! #include "useful.h"
! #include <stdio.h>
! #include <ctype.h>
! #include <sys/file.h>
! #ifndef LOCK_EX
! # include "flock.h"
! #endif /* !LOCK_EX */
  
- #ifdef GDBM
- # define OTHERDBM
- # include <ndbm.h>		/* DBM is typedef'ed here */
- #endif /* GDBM */
- 
- #ifdef SDBM
- # ifdef OTHERDBM
-    MULTIPLE_DBM_TYPES_DEFINED
- # else
- #  define OTHERDBM
- #  include <sdbm.h>		/* DBM is typedef'ed here */
- # endif /* OTHERDBM */
- #endif /* SDBM */
- 
- #ifndef OTHERDBM
- # undef DBM			/* while including ndbm.h */
- # include <ndbm.h>		/* DBM is typedef'ed here */
- #endif /* !OTHERDBM */
- 
- #define DBMFILE DBM
  #define DB_DIREXT	".dir"
  #define DB_PAGEXT	".pag"
  
  #ifndef lint
  static char	SccsId[] = "@(#)dbm.c 2.2 (lel@ida.liu.se) 10/24/88";
! static char	Rcsid[] = "@(#)$Id: dbm.c,v 1.11 1991/06/25 23:50:15 paul Exp $";
  #endif /* !lint */
  
  #define	SAMECASE	0
--- 6,19 ----
  **  Use it, abuse it, but don't sell it.
  */
  
! #include "sendmail.h"
  
  #define DB_DIREXT	".dir"
  #define DB_PAGEXT	".pag"
  
  #ifndef lint
  static char	SccsId[] = "@(#)dbm.c 2.2 (lel@ida.liu.se) 10/24/88";
! static char	Rcsid[] = "@(#)$Id: dbm.c,v 1.12 1991/07/01 17:28:32 paul Exp $";
  #endif /* !lint */
  
  #define	SAMECASE	0
diff -r -c -b sendmail-5.65c/ida/aux/header.c sendmail/ida/aux/header.c
*** sendmail-5.65c/ida/aux/header.c	Tue Jun 25 17:50:32 1991
--- sendmail/ida/aux/header.c	Mon Jul  1 11:29:15 1991
***************
*** 8,25 ****
  **  Version of 14-Apr-85.
  */
  
! #include <stdio.h>
! #include <sys/types.h>
! #include <strings.h>
! #include <ctype.h>
! #include "useful.h"
  
! #define H_CC		"cc"
! #define H_FROM		"from"
! #define H_MESSAGE_ID	"message_id"
! #define H_RETURN_PATH	"return-path"
! #define H_TO		"to"
! #define H_VIA		"via"
  
  #define COMMA	','
  
--- 8,21 ----
  **  Version of 14-Apr-85.
  */
  
! #include "sendmail.h"
  
! #define HH_CC		"cc"
! #define HH_FROM		"from"
! #define HH_MESSAGE_ID	"message_id"
! #define HH_RETURN_PATH	"return-path"
! #define HH_TO		"to"
! #define HH_VIA		"via"
  
  #define COMMA	','
  
***************
*** 26,32 ****
  #define MAKELC(C)	(isupper(C) ? tolower(C) : C)
  
  #ifndef lint
! static char	Rcsid[] = "@(#)$Id: header.c,v 1.3 1991/06/25 23:50:15 paul Exp $";
  #endif /* !lint */
  
  #ifdef __STDC__
--- 22,28 ----
  #define MAKELC(C)	(isupper(C) ? tolower(C) : C)
  
  #ifndef lint
! static char	Rcsid[] = "@(#)$Id: header.c,v 1.4 1991/07/01 17:28:32 paul Exp $";
  #endif /* !lint */
  
  #ifdef __STDC__
diff -r -c -b sendmail-5.65c/ida/aux/mkdomext.c sendmail/ida/aux/mkdomext.c
*** sendmail-5.65c/ida/aux/mkdomext.c	Wed Mar  6 12:11:09 1991
--- sendmail/ida/aux/mkdomext.c	Mon Jul  1 11:36:24 1991
***************
*** 6,14 ****
  **  Use it, abuse it, but don't sell it.
  */
  
! #include "useful.h"
! #include <stdio.h>
! #include <ctype.h>
  
  #ifndef lint
  static char	SccsId[] = "@(#)mkdomext.c 1.5 (lel@ida.liu.se) 4/24/87";
--- 6,12 ----
  **  Use it, abuse it, but don't sell it.
  */
  
! #include "sendmail.h"
  
  #ifndef lint
  static char	SccsId[] = "@(#)mkdomext.c 1.5 (lel@ida.liu.se) 4/24/87";
diff -r -c -b sendmail-5.65c/ida/aux/rmail.c sendmail/ida/aux/rmail.c
*** sendmail-5.65c/ida/aux/rmail.c	Tue Jun 25 17:50:33 1991
--- sendmail/ida/aux/rmail.c	Mon Jul  1 11:29:28 1991
***************
*** 24,59 ****
  */
  
  #ifndef lint
! static char	Rcsid[] = "@(#)$Id: rmail.c,v 1.6 1991/06/25 23:50:15 paul Exp $";
  #endif /* !lint */
  
! #include <stdio.h>
! #include <sys/types.h>
! #include <fcntl.h>
! #include <ctype.h>
! #include <sys/time.h>
! #include <strings.h>
! #include "useful.h"
! 
! #ifdef GDBM
! # define OTHERDBM
! # include <ndbm.h>		/* DBM is typedef'ed here */
! #endif /* GDBM */
! 
! #ifdef SDBM
! # ifdef OTHERDBM
!    MULTIPLE_DBM_TYPES_DEFINED
! # else
! #  define OTHERDBM
! #  include <sdbm.h>		/* DBM is typedef'ed here */
! # endif /* OTHERDBM */
! #endif /* SDBM */
! 
! #ifndef OTHERDBM
! # undef DBM			/* while including ndbm.h */
! # include <ndbm.h>		/* DBM is typedef'ed here */
! #endif /* !OTHERDBM */
! #define DBMFILE DBM
  #define DB_DIREXT	".dir"
  #define DB_PAGEXT	".pag"
  
--- 24,34 ----
  */
  
  #ifndef lint
! static char	Rcsid[] = "@(#)$Id: rmail.c,v 1.7 1991/07/01 17:28:32 paul Exp $";
  #endif /* !lint */
  
! #include "sendmail.h"
! 
  #define DB_DIREXT	".dir"
  #define DB_PAGEXT	".pag"
  
***************
*** 66,77 ****
  #define DEFAULT_DOMAIN	"UUCP"
  /* #define DOMAINTABLE	"/usr/lib/mail/domaintable" */
  
! #define H_CC		"cc"
! #define H_FROM		"from"
! #define H_MESSAGE_ID	"message_id"
! #define H_RETURN_PATH	"return-path"
! #define H_TO		"to"
! #define H_VIA		"via"
  
  #define MAKELC(C)	(isupper(C) ? tolower(C) : C)
  #define EATSPACE(P)	while (*P == ' ') P++
--- 41,52 ----
  #define DEFAULT_DOMAIN	"UUCP"
  /* #define DOMAINTABLE	"/usr/lib/mail/domaintable" */
  
! #define HH_CC		"cc"
! #define HH_FROM		"from"
! #define HH_MESSAGE_ID	"message_id"
! #define HH_RETURN_PATH	"return-path"
! #define HH_TO		"to"
! #define HH_VIA		"via"
  
  #define MAKELC(C)	(isupper(C) ? tolower(C) : C)
  #define EATSPACE(P)	while (*P == ' ') P++
***************
*** 262,269 ****
  #ifdef LOGFILE
  	if (logf != NULL && insideheader &&
  	    ((printedlast && isspace(*s)) ||
! 	     iskey(H_FROM, s) || iskey(H_TO, s) || iskey(H_CC, s) ||
! 	     iskey(H_RETURN_PATH, s) || iskey(H_MESSAGE_ID, s))) {
  		 (void) fprintf(logf, "\t%s\n", s);
  		 printedlast = TRUE;
  	     } else
--- 237,244 ----
  #ifdef LOGFILE
  	if (logf != NULL && insideheader &&
  	    ((printedlast && isspace(*s)) ||
! 	     iskey(HH_FROM, s) || iskey(HH_TO, s) || iskey(HH_CC, s) ||
! 	     iskey(HH_RETURN_PATH, s) || iskey(HH_MESSAGE_ID, s))) {
  		 (void) fprintf(logf, "\t%s\n", s);
  		 printedlast = TRUE;
  	     } else
diff -r -c -b sendmail-5.65c/ida/aux/scanf.c sendmail/ida/aux/scanf.c
*** sendmail-5.65c/ida/aux/scanf.c	Tue Aug 23 05:01:46 1988
--- sendmail/ida/aux/scanf.c	Mon Jul  1 11:36:27 1991
***************
*** 8,16 ****
  **  Very simple version 0.11 of Tue Aug 23 12:01:10 BST 1988
  */
  
! #include "useful.h"
! #include <stdio.h>
! #include <ctype.h>
  
  main(argc, argv)
      int argc;
--- 8,14 ----
  **  Very simple version 0.11 of Tue Aug 23 12:01:10 BST 1988
  */
  
! #include "sendmail.h"
  
  main(argc, argv)
      int argc;
***************
*** 31,37 ****
      }
  
      if (ignore_case)
! 	lower(argv[1]);
  
      if (argc == 2)
  	input = stdin;
--- 29,35 ----
      }
  
      if (ignore_case)
! 	lowerit(argv[1]);
  
      if (argc == 2)
  	input = stdin;
***************
*** 45,57 ****
  
      while (fgets(buf, sizeof(buf), input) != NULL) {
  	if (ignore_case)
! 	    lower(buf);
  	if (sscanf(buf, argv[1], val) == 1)
  	    puts(val);
      }
  }
  
! lower(p)
      register char *p;
  {
      for (; *p != '\0'; p++)
--- 43,55 ----
  
      while (fgets(buf, sizeof(buf), input) != NULL) {
  	if (ignore_case)
! 	    lowerit(buf);
  	if (sscanf(buf, argv[1], val) == 1)
  	    puts(val);
      }
  }
  
! lowerit(p)
      register char *p;
  {
      for (; *p != '\0'; p++)
diff -r -c -b sendmail-5.65c/ida/aux/xalparse.c sendmail/ida/aux/xalparse.c
*** sendmail-5.65c/ida/aux/xalparse.c	Fri Mar 22 09:42:31 1991
--- sendmail/ida/aux/xalparse.c	Fri Jul 12 22:40:44 1991
***************
*** 6,17 ****
  **  Use it, abuse it, but don't sell it.
  */
  
! #include "useful.h"
! #include <stdio.h>
! #include <ctype.h>
  
  #ifndef lint
! static char	rcsid[] = "$Header: /usr1/local/src/sendmail/ida/aux/RCS/xalparse.c,v 1.2 1991/03/18 15:41:29 rickert Exp $";
  #endif /* !lint */
  
  struct alias {
--- 6,15 ----
  **  Use it, abuse it, but don't sell it.
  */
  
! #include "sendmail.h"
  
  #ifndef lint
! static char	rcsid[] = "$Header: /usr/local/src/mail/sendmail/ida/aux/RCS/xalparse.c,v 1.3 1991/07/13 04:40:12 paul Exp $";
  #endif /* !lint */
  
  struct alias {
***************
*** 66,72 ****
    routing_host = NULL;
    Command_Name = argv[0];
  
!   while (*argv[1] == '-') {
  	if (argv[1][1] != 'r' && argv[1][1] != 't') break;
  	if (argv[1][1] == 'r') {
  		routing_host=2+argv[1];
--- 64,70 ----
    routing_host = NULL;
    Command_Name = argv[0];
  
!   while (argc > 1 && *argv[1] == '-') {
  	if (argv[1][1] != 'r' && argv[1][1] != 't') break;
  	if (argv[1][1] == 'r') {
  		routing_host=2+argv[1];
***************
*** 287,293 ****
      quotedchar = FALSE;
    bool i_mark, o_mark;
    char buf[BUFSIZ];
-   extern char *malloc();
  
    s = line;
    d = buf;
--- 285,290 ----
diff -r -c -b sendmail-5.65c/ida/cf/M4/athena.m4 sendmail/ida/cf/M4/athena.m4
*** sendmail-5.65c/ida/cf/M4/athena.m4	Sun Aug 11 22:17:07 1991
--- sendmail/ida/cf/M4/athena.m4	Sun Aug 11 22:26:48 1991
***************
*** 0 ****
--- 1,12 ----
+ # Sendmail configuration file for network-only UIUC hosts with access to
+ # pseudo-domain (bitnet, csnet, etc) MX records.  No phquery support.
+ define(ALIASES, /usr/lib/aliases)
+ define(BANGIMPLIESUUCP)
+ dnl # define(DOMAINTABLE, LIBDIR/domaintable)
+ define(FORCE_NAMED)
+ define(LOCAL_MAILER_DEF, M4/mailers.ptx)dnl ### Sequent Symmetry / ptx settings
+ define(PSEUDODOMAINS, JUNET MAILNET UUCP)
+ define(RELAY_HOST, uxc.cso.uiuc.edu)
+ define(RELAY_MAILER, TCP)
+ define(UUCPNAME, athena)
+ include(Sendmail.mc)
diff -r -c -b sendmail-5.65c/ida/cf/M4/mailers.ptx sendmail/ida/cf/M4/mailers.ptx
*** sendmail-5.65c/ida/cf/M4/mailers.ptx	Sun Aug 11 22:17:07 1991
--- sendmail/ida/cf/M4/mailers.ptx	Sun Jun 30 14:18:49 1991
***************
*** 0 ****
--- 1,3 ----
+ # Mailers for Sequent / ptx systems.
+ Mlocal,	P=/bin/mail, F=DFMlfmns,	R=25/10, S=10, A=mail -d $u
+ Mprog,	P=/bin/sh,  F=DFMhlsu, R=10, S=10, A=sh -c $u
diff -r -c -b sendmail-5.65c/ida/cf/Sendmail.mc sendmail/ida/cf/Sendmail.mc
*** sendmail-5.65c/ida/cf/Sendmail.mc	Wed Jun 26 13:14:58 1991
--- sendmail/ida/cf/Sendmail.mc	Sun Aug 11 22:28:48 1991
***************
*** 1055,1061 ****
  {Cw}DECNETNAME{.dnet}
  
  # We are a DECnet gateway.  Don't supply $u as mail11v3 speaks SMTP.
! MDmail,	P=/usr/bin/mail11v3, F=CmnXNH, S=14, R=14, A=mail11 $f $x $h
  
  ############################################################
  #
--- 1055,1061 ----
  {Cw}DECNETNAME{.dnet}
  
  # We are a DECnet gateway.  Don't supply $u as mail11v3 speaks SMTP.
! MDmail,	P=/usr/bin/mail11v3, F=CmnXNH, S=10/14, R=14, A=mail11 $g $x $h
  
  ############################################################
  #
***************
*** 1708,1714 ****
  R?<$=X$+.$=P>$+		<$1$2.$3?>$4			don't resolv pseudomain
  R?<$=X$+>$+		$:<$1$[ $2 $:$2? $]>$3		First try resolver
  })dnl ### End DOMAINTABLE ###
! R<$=X$w?>$+		<$1$w>$3			Accept official name.
  ifdef({M4COMMENTS},{dnl
  # The next three rules are intended to deal with those improperly configured
  # workstations, which send out addresses of the form <user@unqualified>
--- 1708,1714 ----
  R?<$=X$+.$=P>$+		<$1$2.$3?>$4			don't resolv pseudomain
  R?<$=X$+>$+		$:<$1$[ $2 $:$2? $]>$3		First try resolver
  })dnl ### End DOMAINTABLE ###
! R<$=X$w?>$+		<$1$w>$2			Accept official name.
  ifdef({M4COMMENTS},{dnl
  # The next three rules are intended to deal with those improperly configured
  # workstations, which send out addresses of the form <user@unqualified>
diff -r -c -b sendmail-5.65c/ida/charset/Makefile sendmail/ida/charset/Makefile
*** sendmail-5.65c/ida/charset/Makefile	Fri Apr  5 11:08:50 1991
--- sendmail/ida/charset/Makefile	Tue Jul  2 12:31:48 1991
***************
*** 20,27 ****
  
  all:		$(BINS) CHARDEFS cs/MNEM
  
! gc:		gc.c
! 		$(CC) $(CFLAGS) -o $@ $<
  
  conv:		conv.o strcnv.o
  		$(CC) $(CFLAGS) -o $@ conv.o strcnv.o
--- 20,27 ----
  
  all:		$(BINS) CHARDEFS cs/MNEM
  
! gc:		gc.o
! 		$(CC) $(CFLAGS) -o $@ gc.o
  
  conv:		conv.o strcnv.o
  		$(CC) $(CFLAGS) -o $@ conv.o strcnv.o
***************
*** 34,44 ****
  		./gc
  
  install:	all
  		-mkdir $(LIBDIR)/char
  		tar cf - CHAR* CONTROL ISO* OTHER -C cs . | (cd $(LIBDIR)/char; tar xf -)
  
  clean:
! 		-rm -f \#* *~ *.o $(BINS) CHARDEFS cs/*
  
  .c.o:
  		$(CC) $(CFLAGS) -c $<
--- 34,45 ----
  		./gc
  
  install:	all
+ 		-mkdir $(LIBDIR)
  		-mkdir $(LIBDIR)/char
  		tar cf - CHAR* CONTROL ISO* OTHER -C cs . | (cd $(LIBDIR)/char; tar xf -)
  
  clean:
! 		-rm -f \#* *~ *.o $(BINS) CHARMAP.10646 CHARDEFS cs/*
  
  .c.o:
  		$(CC) $(CFLAGS) -c $<
diff -r -c -b sendmail-5.65c/ida/charset/conv.c sendmail/ida/charset/conv.c
*** sendmail-5.65c/ida/charset/conv.c	Fri Apr  5 11:06:55 1991
--- sendmail/ida/charset/conv.c	Fri Jun 28 12:41:43 1991
***************
*** 4,17 ****
   */
  
  #ifndef lint
! static char Rcsid[] = "@(#)$Header: /usr/local/src/mail/sendmail/ida/charset/RCS/conv.c,v 1.3 1991/04/05 17:06:30 paul Exp $";
  
  #endif
  
  /*
!  * $Header: /usr/local/src/mail/sendmail/ida/charset/RCS/conv.c,v 1.3 1991/04/05 17:06:30 paul Exp $
   *
   * $Log: conv.c,v $
   * Revision 1.3  1991/04/05  17:06:30  paul
   * Eliminated constant strings passed as arguments.
   *
--- 4,20 ----
   */
  
  #ifndef lint
! static char Rcsid[] = "@(#)$Header: /usr/local/src/mail/sendmail/ida/charset/RCS/conv.c,v 1.4 1991/06/28 18:41:20 paul Exp $";
  
  #endif
  
  /*
!  * $Header: /usr/local/src/mail/sendmail/ida/charset/RCS/conv.c,v 1.4 1991/06/28 18:41:20 paul Exp $
   *
   * $Log: conv.c,v $
+  * Revision 1.4  1991/06/28  18:41:20  paul
+  * Replace older xalloc.c with new version from ../../src/util.c .
+  *
   * Revision 1.3  1991/04/05  17:06:30  paul
   * Eliminated constant strings passed as arguments.
   *
***************
*** 120,130 ****
--- 123,141 ----
  **		Memory is allocated.
  */
  
+ #ifdef __STDC__
+ void *
+ #else /* !__STDC__ */
  char *
+ #endif /* __STDC__ */
  xalloc(sz)
  	register int sz;
  {
+ #ifdef __STDC__
+ 	register void *p;
+ #else /* !__STDC__ */
  	register char *p;
+ #endif /* __STDC__ */
  
  	p = malloc((unsigned) sz);
  	if (p == NULL)
***************
*** 133,137 ****
--- 144,149 ----
  		abort();
  		/* exit(EX_UNAVAILABLE); */
  	}
+ 	bzero((char *) p, sz);
  	return (p);
  }
diff -r -c -b sendmail-5.65c/ida/charset/strcnv.c sendmail/ida/charset/strcnv.c
*** sendmail-5.65c/ida/charset/strcnv.c	Fri Apr  5 11:11:54 1991
--- sendmail/ida/charset/strcnv.c	Fri Jun 28 12:07:02 1991
***************
*** 29,35 ****
  
  #ifdef	BIT8
  # ifndef lint
! static char RcsId[] = "@(#)$Header: /usr/local/src/mail/sendmail/ida/charset/RCS/strcnv.c,v 2.1 1991/04/05 17:11:49 paul Exp $";
  # endif /* !lint */
  
  # ifndef MAPDIR
--- 29,35 ----
  
  #ifdef	BIT8
  # ifndef lint
! static char RcsId[] = "@(#)$Header: /usr/local/src/mail/sendmail/ida/charset/RCS/strcnv.c,v 2.2 1991/06/28 18:05:36 paul Exp $";
  # endif /* !lint */
  
  # ifndef MAPDIR
***************
*** 245,251 ****
  		return (NULL);
  
  	/* Loop through the chain of character set names. */
! 	for (c = charsets; c && strcasecmp(c->name, s); c = c->next)
  		c1 = c;
  
  	/*
--- 245,251 ----
  		return (NULL);
  
  	/* Loop through the chain of character set names. */
! 	for (c = charsets; c && strcmp(c->name, s); c = c->next)
  		c1 = c;
  
  	/*
diff -r -c -b sendmail-5.65c/src/Makefile sendmail/src/Makefile
*** sendmail-5.65c/src/Makefile	Tue Jun 25 00:26:01 1991
--- sendmail/src/Makefile	Sun Aug 11 21:25:45 1991
***************
*** 15,23 ****
  # WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
  #
  #	@(#)Makefile	5.11 (Berkeley) 1/3/89
! #	@(#)$Id: Makefile,v 1.14 1991/06/25 05:26:29 paul Exp $
  #
! HDRS=	conf.h mailstats.h sendmail.h useful.h
  SRCS=	alias.c arpadate.c clock.c collect.c conf.c convtime.c daemon.c \
  	deliver.c domain.c envelope.c err.c getloadavg.c headers.c \
  	macro.c main.c parseaddr.c queue.c readcf.c recipient.c \
--- 15,23 ----
  # WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
  #
  #	@(#)Makefile	5.11 (Berkeley) 1/3/89
! #	@(#)$Id: Makefile,v 1.16 1991/08/12 02:38:09 paul Exp $
  #
! HDRS=	conf.h mailstats.h sendmail.h useful.h flock.h def.h
  SRCS=	alias.c arpadate.c clock.c collect.c conf.c convtime.c daemon.c \
  	deliver.c domain.c envelope.c err.c getloadavg.c headers.c \
  	macro.c main.c parseaddr.c queue.c readcf.c recipient.c \
***************
*** 30,35 ****
--- 30,43 ----
  	savemail.o srvrsmtp.o stab.o stats.o sysexits.o trace.o \
  	usersmtp.o util.o strcnv.o flock.o setenv.o syslog.o vprintf.o \
  	version.o
+ CONFIGS = \
+ 	config/3b1.h      config/dynix.h    config/ptx.h \
+ 	config/aix3.h     config/hpux.h     config/riscos.h \
+ 	config/aixrt.h    config/irix.h     config/sunos4.h \
+ 	config/bsd43.h    config/isc.h      config/ultrix3.h \
+ 	config/bsd44.h    config/next.h     config/ultrix4.h \
+ 	config/convex.h   config/osx.h      config/umax.h \
+ 	config/domainos.h 
  MAN=	sendmail.0 newaliases.0 aliases.0
  
  SHELL=	/bin/sh
***************
*** 189,194 ****
--- 197,208 ----
  
  lint: ${SRCS}
  	lint -chpb -I. ${DEFS} ${SRCS}
+ 
+ # However we put in one default dependency, to minimize the problems of those
+ # who don't do a 'make depend'
+ 
+ $(OBJS):	$(HDRS) $(CONFIGS)
+ 
  # DO NOT DELETE THIS LINE -- mkdep uses it.
  # DO NOT PUT ANYTHING AFTER THIS LINE, IT WILL GO AWAY.
  
diff -r -c -b sendmail-5.65c/src/RELEASEDATE sendmail/src/RELEASEDATE
*** sendmail-5.65c/src/RELEASEDATE	Fri Mar  8 16:54:00 1991
--- sendmail/src/RELEASEDATE	Thu Jun 27 09:12:05 1991
***************
*** 1,3 ****
--- 1,4 ----
  Tue Oct 16 10:42:26 CDT 1990
  Fri Dec 14 17:55:09 CST 1990
  Fri Mar  8 16:53:44 CST 1991
+ Wed Jun 26 10:11:39 CDT 1991
diff -r -c -b sendmail-5.65c/src/alias.c sendmail/src/alias.c
*** sendmail-5.65c/src/alias.c	Fri Jun 21 06:17:13 1991
--- sendmail/src/alias.c	Thu Aug  8 16:13:29 1991
***************
*** 38,47 ****
  #ifndef lint
  # ifdef DBM
  static char sccsid[] = "@(#)alias.c	5.21 (Berkeley) 6/1/90 (with DBM)";
! static char rcsid[] = "@(#)$Id: alias.c,v 5.21.0.21 1991/06/21 12:16:37 paul Exp $ (with DBM)";
  # else /* !DBM */
  static char sccsid[] = "@(#)alias.c	5.21 (Berkeley) 6/1/90 (without DBM)";
! static char rcsid[] = "@(#)$Id: alias.c,v 5.21.0.21 1991/06/21 12:16:37 paul Exp $ (without DBM)";
  # endif /* DBM */
  #endif /* not lint */
  
--- 38,47 ----
  #ifndef lint
  # ifdef DBM
  static char sccsid[] = "@(#)alias.c	5.21 (Berkeley) 6/1/90 (with DBM)";
! static char rcsid[] = "@(#)$Id: alias.c,v 5.21.0.23 1991/08/08 22:13:25 paul Exp $ (with DBM)";
  # else /* !DBM */
  static char sccsid[] = "@(#)alias.c	5.21 (Berkeley) 6/1/90 (without DBM)";
! static char rcsid[] = "@(#)$Id: alias.c,v 5.21.0.23 1991/08/08 22:13:25 paul Exp $ (without DBM)";
  # endif /* DBM */
  #endif /* not lint */
  
***************
*** 125,130 ****
--- 125,133 ----
  		printf("%s (%s, %s) aliased to %s\n",
  		    a->q_paddr, a->q_host, a->q_user, p);
  	message(Arpa_Info, "aliased to %s", p);
+ 
+ 	/* sendtolist() will detect a possible self-reference for this alias */
+ 	a->q_flags &= ~QSELFREF;
  	AliasLevel++;
  	sendtolist(p, a, sendq);
  	AliasLevel--;
***************
*** 701,707 ****
  	if (!safefile(buf, user->q_uid, S_IREAD))
  		return;
  
! 	/* we do have an address to forward to -- do it */
  	include(buf, "forwarding", user, sendq);
  }
  /*
--- 704,714 ----
  	if (!safefile(buf, user->q_uid, S_IREAD))
  		return;
  
! 	/*
! 	 * we do have an address to forward to -- do it but
! 	 * don't carry over selfref from alias.
! 	 */
! 	user->q_flags &= ~QSELFREF;
  	include(buf, "forwarding", user, sendq);
  }
  /*
diff -r -c -b sendmail-5.65c/src/arpadate.c sendmail/src/arpadate.c
*** sendmail-5.65c/src/arpadate.c	Wed Jun 26 22:43:52 1991
--- sendmail/src/arpadate.c	Thu Jun 27 23:53:47 1991
***************
*** 20,26 ****
  
  #ifndef lint
  static char sccsid[] = "@(#)arpadate.c	5.11 (Berkeley) 6/1/90";
! static char rcsid[] = "@(#)$Id: arpadate.c,v 5.11.0.9 1991/06/27 04:42:05 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 20,26 ----
  
  #ifndef lint
  static char sccsid[] = "@(#)arpadate.c	5.11 (Berkeley) 6/1/90";
! static char rcsid[] = "@(#)$Id: arpadate.c,v 5.11.0.10 1991/06/28 05:52:38 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 301,310 ****
  			p += 3;
  			break;
  		}
- 
- 	/* skip over months that are spelled out, e.g., June */
- 	while (*p && isalpha(*p))
- 		p++;
  
  	p = nextatom(p);			/* year */
  	tm.tm_year = atoi(p);
--- 301,306 ----
diff -r -c -b sendmail-5.65c/src/daemon.c sendmail/src/daemon.c
*** sendmail-5.65c/src/daemon.c	Fri Jun 21 06:44:18 1991
--- sendmail/src/daemon.c	Mon Aug 12 11:53:22 1991
***************
*** 27,36 ****
  #ifndef lint
  # ifdef DAEMON
  static char sccsid[] = "@(#)daemon.c	5.36 (Berkeley) 6/1/90 (with daemon mode)";
! static char rcsid[] = "@(#)$Id: daemon.c,v 5.36.0.24 1991/06/21 12:41:25 paul Exp $ (with daemon mode)";
  # else /* !DAEMON */
  static char sccsid[] = "@(#)daemon.c	5.36 (Berkeley) 6/1/90 (without daemon mode)";
! static char rcsid[] = "@(#)$Id: daemon.c,v 5.36.0.24 1991/06/21 12:41:25 paul Exp $ (without daemon mode)";
  # endif /* DAEMON */
  #endif /* not lint */
  
--- 27,36 ----
  #ifndef lint
  # ifdef DAEMON
  static char sccsid[] = "@(#)daemon.c	5.36 (Berkeley) 6/1/90 (with daemon mode)";
! static char rcsid[] = "@(#)$Id: daemon.c,v 5.36.0.27 1991/08/12 17:52:32 paul Exp $ (with daemon mode)";
  # else /* !DAEMON */
  static char sccsid[] = "@(#)daemon.c	5.36 (Berkeley) 6/1/90 (without daemon mode)";
! static char rcsid[] = "@(#)$Id: daemon.c,v 5.36.0.27 1991/08/12 17:52:32 paul Exp $ (without daemon mode)";
  # endif /* DAEMON */
  #endif /* not lint */
  
***************
*** 554,560 ****
--- 554,576 ----
  		Xsleep(10);
  	}
  # else /* !NAMED_BIND */
+ #  ifdef sun
+ 	/*
+ 	 *	An ugly hack.
+ 	 *	This routine is mainly called to assign a default value
+ 	 *	to $w .  As such it must be called before the config file
+ 	 *	is processed.  On Sun systems this involves calls to some
+ 	 *	of the yp lookup routines.  They apparently leave state
+ 	 *	information lying around which is inconsistent with the
+ 	 *	use of frozen configurations.  Since the standard Sun
+ 	 *	setup leaves hostnames unqualified anyway, omitting the
+ 	 *	gethostbyname() call should have little effect.
+ 	 */
+ 
+ 	hp = NULL;
+ #  else /* !sun */
  	hp = gethostbyname(hostbuf);
+ #  endif /* sun */
  # endif /* NAMED_BIND */
  	if (hp != NULL)
  	{
***************
*** 921,929 ****
  		    yp_match(yp_domain, &db->db_name[1], lowkey,
  		    strlen(key), &result.dptr, &result.dsize) != 0)
  			result.dptr = NULL;
! 		else
! 			/* smash newline */
! 			result.dptr[result.dsize--] = '\0';
  	}
  	else
  	{
--- 937,946 ----
  		    yp_match(yp_domain, &db->db_name[1], lowkey,
  		    strlen(key), &result.dptr, &result.dsize) != 0)
  			result.dptr = NULL;
! 
! 		/* smash newline if supplied */
! 		else if (result.dptr[result.dsize] == '\n')
! 			result.dptr[result.dsize] = '\0';
  	}
  	else
  	{
diff -r -c -b sendmail-5.65c/src/deliver.c sendmail/src/deliver.c
*** sendmail-5.65c/src/deliver.c	Fri Jun 21 06:45:58 1991
--- sendmail/src/deliver.c	Sun Aug 11 20:36:59 1991
***************
*** 20,26 ****
  
  #ifndef lint
  static char sccsid[] = "@(#)deliver.c	5.38 (Berkeley) 6/1/90";
! static char  rcsid[] = "@(#)$Id: deliver.c,v 5.38.0.31 1991/06/21 12:45:31 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 20,26 ----
  
  #ifndef lint
  static char sccsid[] = "@(#)deliver.c	5.38 (Berkeley) 6/1/90";
! static char  rcsid[] = "@(#)$Id: deliver.c,v 5.38.0.32 1991/08/12 02:36:50 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 1265,1307 ****
  	const char *stat;
  {
  # ifdef LOG
  #  if defined(hpux)
! #   define LOGSPLIT 128
  #  else /* hpux */
! #   define LOGSPLIT 900
  # endif /* hpux */
  	register char *p, *q;
  
  	/*
! 	** Split up long To: lines, since the buffer in
! 	** syslog() on various systems isn't large enough.
  	*/
  	p = CurEnv->e_to;
! 	while (strlen(p) >= LOGSPLIT)
! 	{
! 		if ((q = index(p + LOGSPLIT, ',')) != NULL)
! 		{
  			if (m == NULL)
! 				syslog(LOG_INFO, "%s: to=%.*s(cont'd), delay=%s, stat=%s",
! 					CurEnv->e_id, q - p + 1, p,
  					pintvl(curtime()-CurEnv->e_ctime, TRUE),
  					stat);
  			else
! 				syslog(LOG_INFO, "%s: to=%.*s(cont'd), delay=%s, stat=%s, mailer=%s",
! 					CurEnv->e_id, q - p + 1, p,
  					pintvl(curtime()-CurEnv->e_ctime, TRUE),
  					stat, m->m_name);
  			p = q + 1;
  		}
  		else
  			break;
  	}
! 	if (m == NULL)
! 		syslog(LOG_INFO, "%s: to=%s, delay=%s, stat=%s", CurEnv->e_id,
! 			p, pintvl(curtime() - CurEnv->e_ctime, TRUE), stat);
! 	else
! 		syslog(LOG_INFO, "%s: to=%s, delay=%s, stat=%s, mailer=%s",
! 			CurEnv->e_id, p, pintvl(curtime()-CurEnv->e_ctime,TRUE),			 stat, m->m_name);
  # endif /* LOG */
  }
  /*
--- 1265,1324 ----
  	const char *stat;
  {
  # ifdef LOG
+ 	/*
+ 	** These buffer sizes are based on the total bufsize available in the
+ 	** syslog() implementation. On BSD based systems the buffer is 1024,
+ 	** on HP-UX it is only 256 bytes. These sizes are less to allow
+ 	** for the header that syslog prepends to the messages which are sent
+ 	** below. Overflow of the buffer can result in duplicate mail messages
+ 	** to long lists.
+ 	*/
  #  if defined(hpux)
! #   define LOG_BUFSIZE 156
  #  else /* hpux */
! #   define LOG_BUFSIZE 900
  # endif /* hpux */
  	register char *p, *q;
+ 	register int logsplit;
+ 	char trailer[128];
  			
  	/*
! 	** Split up long To: lines, since the buffer in syslog() on various
! 	** systems isn't large enough.  Some syslog() implementations, e.g.,
! 	** Ultrix, limit the number of printf parameters to 5.
  	*/
  	p = CurEnv->e_to;
! 
! 	/*
! 	** Take care that the info going into trailer[] is less than
! 	** 128 bytes long. If it gets that big then on systems with
! 	** short syslog buffers we won't get many addresses in anyway.
! 	*/
  	if (m == NULL)
! 	{
! 	    (void) sprintf(trailer,"delay=%s, stat=%s",
  			   pintvl(curtime()-CurEnv->e_ctime, TRUE),
  			   stat);
+ 	}
  	else	    
! 	{
! 	    (void) sprintf(trailer,"delay=%s, stat=%s, mailer=%s",
  			   pintvl(curtime()-CurEnv->e_ctime, TRUE),
  			   stat, m->m_name);
+ 	}
+ 	logsplit = LOG_BUFSIZE - strlen(trailer);
+ 	while (strlen(p) >= logsplit)
+ 	{
+ 		if ((q = index(p + logsplit, ',')) != NULL)
+ 		{
+ 		        syslog(LOG_INFO, "%s: to=%.*s(cont'd), %s",
+ 			       CurEnv->e_id, q - p + 1, p, trailer);
  		        p = q + 1;
  		}
  		else
  			break;
  	}
! 	syslog(LOG_INFO, "%s: to=%s, %s", CurEnv->e_id, p, trailer);
  # endif /* LOG */
  }
  /*
diff -r -c -b sendmail-5.65c/src/main.c sendmail/src/main.c
*** sendmail-5.65c/src/main.c	Mon Jun 24 23:25:44 1991
--- sendmail/src/main.c	Tue Aug  6 12:17:26 1991
***************
*** 25,31 ****
  "@(#) Copyright (c) 1988 Regents of the University of California.\n\
   All rights reserved.\n";
  static char sccsid[] = "@(#)main.c	5.31 (Berkeley) 7/20/90";
! static char  rcsid[] = "@(#)$Id: main.c,v 5.29.0.33 1991/06/25 05:25:13 paul Exp $";
  # ifdef	__GNUC__
  static	char	compiled[] = "@(#)compiled by gcc version "__VERSION__;
  # endif	/* __GNUC__ */
--- 25,31 ----
  "@(#) Copyright (c) 1988 Regents of the University of California.\n\
   All rights reserved.\n";
  static char sccsid[] = "@(#)main.c	5.31 (Berkeley) 7/20/90";
! static char  rcsid[] = "@(#)$Id: main.c,v 5.29.0.36 1991/08/06 18:17:12 paul Exp $";
  # ifdef	__GNUC__
  static	char	compiled[] = "@(#)compiled by gcc version "__VERSION__;
  # endif	/* __GNUC__ */
***************
*** 210,229 ****
  	STRUCTCOPY(NullAddress, MainEnvelope.e_from);
  
  	argv[argc] = NULL;
- #ifdef notdef
- 	/* Print the argument list when debugging */
- 	{
- 		char	*cmdline = xalloc(MAXLINE);
- 
- 		for (*cmdline = '\0', av = argv; *av; av++)
- 		{
- 			(void) strcat(cmdline, *av);
- 			(void) strcat(cmdline, " ");
- 		}
- 		syslog(LOG_DEBUG, "Invoked as: %s", cmdline);
- 		free(cmdline);
- 	}
- #endif /* notdef */
  	av = argv;
  	nothaw = FALSE;
  
--- 210,215 ----
***************
*** 360,370 ****
  				if (tTd(0, 4))
  					printf("UUCP nodename: %s\n",
  					    utsname.nodename);
! # ifdef LOG
! 				syslog(LOG_NOTICE, "UUCP nodename (%s) and lowest level of canonical name (%s) differ",
! 					utsname.nodename, jbuf);
! # endif /* LOG */
! 			} else
  #endif /* HAS_UNAME */
  			define('k', newstr(jbuf), CurEnv);
  		}
--- 346,353 ----
  				if (tTd(0, 4))
  					printf("UUCP nodename: %s\n",
  					    utsname.nodename);
! 			}
! 			else
  #endif /* HAS_UNAME */
  			define('k', newstr(jbuf), CurEnv);
  		}
***************
*** 649,654 ****
--- 632,671 ----
  		break;
  	}
  
+ #ifdef notdef
+ 	/*
+ 	 * Print the argument list when debugging.  This has to come after the
+ 	 * freeze() statement as the first syslog() call sets a state variable
+ 	 * that won't get saved or restored.
+ 	 */
+ 	{
+ 		char	*cmdline = xalloc(MAXLINE);
+ 
+ 		for (*cmdline = '\0', av = argv; *av; av++)
+ 		{
+ 			(void) strcat(cmdline, *av);
+ 			(void) strcat(cmdline, " ");
+ 		}
+ 		syslog(LOG_DEBUG, "Invoked as: %s", cmdline);
+ 		free(cmdline);
+ 	}
+ #endif /* notdef */
+ 
+ 	/*
+ 	 *	The call to setdefuser() is moved from readcf.c to here.
+ 	 *	The result is only used in deliver.c, so delaying it until
+ 	 *	now should be safe.
+ 	 *
+ 	 *	The function setdefuser() looks up the passwd database.  In
+ 	 *	some systems, notably Suns, this may involve a YP lookup.
+ 	 *	Unfortunately YP lookups leave behind some state information
+ 	 *	which seems to be incompatible with the freeze/thaw operations.
+ 	 *
+ 	 *	Placing the call here delays it till after the freeze/thaw
+ 	 *	is complete.
+ 	 */
+ 	setdefuser();
+ 
  	/* do heuristic mode adjustment */
  	if (Verbose)
  	{
***************
*** 1106,1112 ****
  
  	if (freezefile == NULL)
  		return;
! # ifdef YP
  	{
  		/*
  		 * NIS (nee YP) state is saved in the freeze, the readback
--- 1123,1129 ----
  
  	if (freezefile == NULL)
  		return;
! # ifdef notdef
  	{
  		/*
  		 * NIS (nee YP) state is saved in the freeze, the readback
***************
*** 1186,1198 ****
  	if (f < 0)
  	{
  # ifdef LOG
! 		syslog(LOG_WARNING, "Cannot open frozen config file %s: %m",
  			freezefile);
  # endif /* LOG */
  		errno = 0;
  		return (FALSE);
  	}
! # ifdef YP
  	{
  		/*
  		 * NIS (nee YP) state is saved in the freeze, the readback
--- 1203,1215 ----
  	if (f < 0)
  	{
  # ifdef LOG
! 		syslog(LOG_NOTICE, "Cannot open frozen config file %s: %m",
  			freezefile);
  # endif /* LOG */
  		errno = 0;
  		return (FALSE);
  	}
! # ifdef notdef
  	{
  		/*
  		 * NIS (nee YP) state is saved in the freeze, the readback
diff -r -c -b sendmail-5.65c/src/readcf.c sendmail/src/readcf.c
*** sendmail-5.65c/src/readcf.c	Mon Jun 24 10:20:51 1991
--- sendmail/src/readcf.c	Tue Aug  6 12:17:15 1991
***************
*** 20,26 ****
  
  #ifndef lint
  static char sccsid[] = "@(#)readcf.c	5.21 (Berkeley) 6/1/90";
! static char  rcsid[] = "@(#)$Id: readcf.c,v 5.21.0.13 1991/06/24 16:20:25 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 20,26 ----
  
  #ifndef lint
  static char sccsid[] = "@(#)readcf.c	5.21 (Berkeley) 6/1/90";
! static char  rcsid[] = "@(#)$Id: readcf.c,v 5.21.0.15 1991/08/06 18:17:12 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 101,107 ****
  		exit(EX_OSFILE);
  	}
  
! 	setdefuser();
  	FileName = cfname;
  	LineNumber = 0;
  	while (fgetfolded(buf, sizeof buf, cf) != NULL)
--- 101,107 ----
  		exit(EX_OSFILE);
  	}
  
! 	/* setdefuser(); Moved to main.c - see comments there */
  	FileName = cfname;
  	LineNumber = 0;
  	while (fgetfolded(buf, sizeof buf, cf) != NULL)
***************
*** 1034,1042 ****
  		break;
  
  	  case 'N':		/* home (local?) network name */
! # ifdef LOG
! 		syslog(LOG_ERR, "'%c' option is obsolete", opt);
! # endif /* LOG */
  		break;
  
  	  case 'o':		/* assume old style headers */
--- 1034,1040 ----
  		break;
  
  	  case 'N':		/* home (local?) network name */
! 		syserr("Option N is obsolete (ON in sendmail.cf or -oN on command line)");
  		break;
  
  	  case 'o':		/* assume old style headers */
***************
*** 1085,1091 ****
  
  	  case 'u':		/* set default uid */
  		DefUid = atoi(val);
! 		setdefuser();
  		break;
  
  	  case 'v':		/* run in verbose mode */
--- 1083,1089 ----
  
  	  case 'u':		/* set default uid */
  		DefUid = atoi(val);
! 		/* setdefuser(); Moved to main.c - see comments there */
  		break;
  
  	  case 'v':		/* run in verbose mode */
diff -r -c -b sendmail-5.65c/src/recipient.c sendmail/src/recipient.c
*** sendmail-5.65c/src/recipient.c	Mon Jun 24 10:22:34 1991
--- sendmail/src/recipient.c	Thu Aug  8 16:13:17 1991
***************
*** 20,26 ****
  
  #ifndef lint
  static char sccsid[] = "@(#)recipient.c	5.18 (Berkeley) 6/1/90";
! static char  rcsid[] = "@(#)$Id: recipient.c,v 5.18.0.12 1991/06/24 16:21:32 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 20,26 ----
  
  #ifndef lint
  static char sccsid[] = "@(#)recipient.c	5.18 (Berkeley) 6/1/90";
! static char  rcsid[] = "@(#)$Id: recipient.c,v 5.18.0.13 1991/08/08 22:13:13 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 638,643 ****
--- 638,646 ----
  		ctladdr->q_gid = st.st_gid;
  		ctladdr->q_flags |= QGOODUID;
  	}
+ 
+ 	/* sendtolist() detects possible self-refs in any line of this file */
+ 	ctladdr->q_flags &= ~QSELFREF;
  
  	/* read the file -- each line is a comma-separated list. */
  	FileName = (char *)fname;
diff -r -c -b sendmail-5.65c/src/util.c sendmail/src/util.c
*** sendmail-5.65c/src/util.c	Mon Jun 24 14:32:09 1991
--- sendmail/src/util.c	Thu Aug  8 16:08:22 1991
***************
*** 20,26 ****
  
  #ifndef lint
  static char sccsid[] = "@(#)util.c	5.18 (Berkeley) 6/1/90";
! static char  rcsid[] = "@(#)$Id: util.c,v 5.18.0.13 1991/06/24 20:31:52 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 20,26 ----
  
  #ifndef lint
  static char sccsid[] = "@(#)util.c	5.18 (Berkeley) 6/1/90";
! static char  rcsid[] = "@(#)$Id: util.c,v 5.18.0.14 1991/08/08 22:08:18 paul Exp $";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 438,444 ****
  {
  	struct stat stbuf;
  
! 	if (stat(fn, &stbuf) >= 0 && stbuf.st_uid == uid &&
  	    (stbuf.st_mode & mode) == mode)
  		return (TRUE);
  	errno = 0;
--- 438,444 ----
  {
  	struct stat stbuf;
  
! 	if (stat(fn, &stbuf) >= 0 && stbuf.st_uid == (uid_t) uid &&
  	    (stbuf.st_mode & mode) == mode)
  		return (TRUE);
  	errno = 0;
diff -r -c -b sendmail-5.65c/support/strcasecmp.c sendmail/support/strcasecmp.c
*** sendmail-5.65c/support/strcasecmp.c	Sun Jun 16 15:54:19 1991
--- sendmail/support/strcasecmp.c	Wed Aug  7 09:00:09 1991
***************
*** 83,89 ****
  #ifdef __STDC__
  strncasecmp(const char *s1, const char *s2, int n)
  #else /* !__STDC__ */
! strncasecmp(s1, s2)
  	char *s1, *s2;
  	register int n;
  #endif /* __STDC__ */
--- 83,89 ----
  #ifdef __STDC__
  strncasecmp(const char *s1, const char *s2, int n)
  #else /* !__STDC__ */
! strncasecmp(s1, s2, n)
  	char *s1, *s2;
  	register int n;
  #endif /* __STDC__ */
